# 9gag Media Downloader

This command-line tool automates the downloading of media (pictures and videos) from 9gag posts or comments in a variety of ways.

#### Use Cases
* There is a user who posts really nice wallpapers, and you want to download those pictures from all of his posts.

* For a given post, there are very good videos in its comments, and you want to get all of those videos.

* A user, as a rule, comments on really interesting posts, and you want the media of all such posts.
* So on...

If you use and like this tool, considering passing a small token of appreciation by going to https://randompearls.com/reference/tools/9gag-media-downloader, and making a small donation to the [website](https://randompearls.com/reference/tools/9gag-media-downloader#a-reason-to-donate).

## License

By using this tool to save media from 9gag on your own device, you agree to not post this media in the form of memes or any other way elsewhere if the media is copyrighted.
The onus of determining copyright on the media and respecting it is on the user of the tool.

The tool itself has been released under Creative Commons ShareAlike License which, in summary, means non-commercial adaptation and/or redistribution of the tool is allowed with attribution (to https://randompearls.com/reference/tools/9gag-media-downloader).

Click on the links below for reading more about the license.


[![CC BY-NC-SA 4.0][cc-by-nc-sa-shield]][cc-by-nc-sa]

This work is licensed under a
[Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License][cc-by-nc-sa].

[![CC BY-NC-SA 4.0][cc-by-nc-sa-image]][cc-by-nc-sa]

[cc-by-nc-sa]: http://creativecommons.org/licenses/by-nc-sa/4.0/
[cc-by-nc-sa-image]: https://licensebuttons.net/l/by-nc-sa/4.0/88x31.png
[cc-by-nc-sa-shield]: https://img.shields.io/badge/License-CC%20BY--NC--SA%204.0-lightgrey.svg


## Usage
There are different ways in which the media can be downloaded, e.g. from all the comments on a post, for all the posts posted by a user etc.

The tool runs on command line and has been tested on Windows and Linux e.g.
```bash
9gdownload
9gdownload -c <path_of_config.txt>
```

The only (optional) argument the tool needs is `-c` which tells the tool the location of the config file. This config file is otherwise expected to be located in the same folder where the tool resides (with the name `config.txt`).

All the options present in the config file are explained below.  
There are three types of configuration values. You can modify them in the config file.

### Changed Often
|Option and Type|Description
|-|-|
|`token` (str)|The key determining a post, interest, tag or a user. Can be obtained from the URL as shown below:<br>- Post key: https://9gag.com/gag/\<postkey\><br>- username: https://9gag.com/u/\<uername\><br>- tag: https://9gag.com/tag/\<tag\><br>- interest: https://9gag.com/interest/\<interest\><br>This options is not used (needed) with the `DEFAULT` `gag_type`.|
|`gag_type` (str)|Where to get the media from.<br>`POST_COMMENTS`: from comments on a given post<br>`USER_POSTS`: from posts posted by a given user<br>`USER_LIKES`: from posts liked by a given user<br>`USER_COMMENTS`: from posts commented on by a given user<br>`USER_SAVED`: from posts saved by the user (this needs authorization, see `PHPSESSID` and `session`)<br>`TAG`<br>`INTEREST`<br>`DEFAULT`: from 9gag home page|
|`gag_subtype` (str)|Further specifies the type of page to get media from. Works in conjunction with `gag_type`.<br>- `HOT` (goes with only `TAG` and `INTEREST`)<br>- `FRESH` (for `TAG`, `INTEREST` and `DEFAULT`)<br>- `HOME` goes with only `DEFAULT`<br>- `TOP` goes with only `DEFAULT`<br>- `TRENDING` goes with only `DEFAULT`|
|`PHPSESSID` (str) and `session` (str)|Needed only for the `USER_SAVED` `gag_type`.<br>To get these values, go to Developer tools (in your browser) -> Network, and filter for requests having `saved?` - will have to scroll a bit. Then from its Cookies, copy these two values.|

### Changed Sometimes
|Option and Type|Description
|-|-|
|`root_folder` (str)|Must exist. This is where a folder will be created for saving media.|
|`removed_folder_suffix` (str)|Good for multiple runs. If you create a folder with the media folder name and this suffix, files that you move to this folder manually will not be re-downloaded. Helps in keeping the media folder clean.|
|`should_save` (bool)|If `False`, media urls will only be shown, but not saved||
|`get_image_only` (bool)|If True, videos will not be downloaded|
|`get_image_with_video` (bool)|If True, get images as well for videos, ineffective with `get_image_only=True`|
|`max_save_workers` (int)|There is only one find worker thread (for media URLs discovery), but for saving we can have multiple as specified by this option|
|`pause_find` (bool)|Should or not pause (for a keypress) after every run of url discovery, `True` is recommended||
|`overwrite` (bool)|Overwrite or not the existing files in subsequent runs|
|`sleeptime` (float)|Time between saves. Do not make it zero or it may trigger DoS attack on the server.|

### Changed Rarely
|Option and Type|Description
|-|-|
|`headers` (dict)|The headers sent with the requests.|
|`appId` (str)||
|`auth_key` (str)|Not needed currently|
